Skip to content
Back to Knowledge Base

Set up Storybook for React Projects

Walk you through setting up Storybook for React projects in your Nx workspace.

Generate Storybook Configuration for a React project

Section titled “Generate Storybook Configuration for a React project”

You can generate Storybook configuration for an individual React project by using the @nx/react:storybook-configuration generator, like this:

Terminal window
nx g @nx/react:storybook-configuration project-name

The @nx/react:storybook-configuration generator has the option to automatically generate *.stories.ts|tsx files for each component declared in the library. The stories will be generated using Component Story Format 3 (CSF3).

  • Directory<some-folder>/
    • my-component.tsx
    • my-component.stories.tsx

If you add more components to your project, and want to generate stories for all your (new) components at any point, you can use the @nx/react:stories generator:

Terminal window
nx g @nx/react:stories --project=<project-name>

Let's take for a example a library in your workspace, under libs/feature/ui, called feature-ui. This library contains a component, called my-button.

The command to generate stories for that library would be:

Terminal window
nx g @nx/react:stories --project=feature-ui

and the result would be the following:

  • Directoryworkspace-name/
    • Directoryapps/
    • Directorylibs/
      • Directoryfeature/
        • Directoryui/
          • Directory.storybook/
        • Directorysrc/
          • Directorylib/
            • Directorymy-button/
              • my-button.tsx
              • my-button.stories.tsx
          • etc...
        • README.md
        • tsconfig.json
    • nx.json
    • package.json
    • README.md

Let's take for a example a library in your workspace, under libs/feature/ui, called feature-ui with a component, called my-button.

Let's say that your component code looks like this:

libs/feature/ui/src/lib/my-button/my-button.tsx
export interface MyButtonProps {
text: string;
padding: number;
disabled: boolean;
}
export function MyButton(props: MyButtonProps) {
return (
<button disabled={props.disabled} style={{ padding: props.padding }}>
{props.text}
</button>
);
}
export default MyButton;

The @nx/react:storybook-configuration generator would generate a Story file that looks like this:

libs/feature/ui/src/lib/my-button/my-button.stories.tsx
import type { Meta, StoryObj } from '@storybook/react-vite';
import { MyButton } from './my-button';
import { within } from '@storybook/testing-library';
import { expect } from '@storybook/jest';
const meta = {
component: MyButton,
title: 'MyButton',
} satisfies Meta<typeof MyButton>;
export default meta;
type Story = StoryObj<typeof MyButton>;
export const Primary = {
args: {
text: '',
padding: 0,
disabled: false,
},
} satisfies Story;
export const Heading = {
args: {
text: '',
padding: 0,
disabled: false,
},
play: async ({ canvasElement }) => {
const canvas = within(canvasElement);
expect(canvas.getByText(/MyButton!/gi)).toBeTruthy();
},
} satisfies Story;

Notice the interaction test on the second story, inside the play function. This just tests if the default text that appears on generated components exists in the rendered component. You can edit this test to suit your needs. You can read more about interaction tests here.

You can find all Storybook-related Nx topics here.

For more on using Storybook, see the official Storybook documentation.

Here's more information on common migration scenarios for Storybook with Nx. For Storybook specific migrations that are not automatically handled by Nx please refer to the official Storybook page

Last updated:

Skip to content
Back to Knowledge Base

Set up Storybook for Angular Projects

Walk you through setting up Storybook for Angular projects in your Nx workspace.

Generate Storybook Configuration for an Angular project

Section titled “Generate Storybook Configuration for an Angular project”

You can generate Storybook configuration for an individual Angular project by using the @nx/angular:storybook-configuration generator, like this:

Terminal window
nx g @nx/angular:storybook-configuration project-name

The @nx/angular:storybook-configuration generator has the option to automatically generate *.stories.ts files for each component declared in the library. The stories will be generated using Component Story Format 3 (CSF3).

  • Directory<some-folder>/
    • my-component.ts
    • my-component.stories.ts

If you add more components to your project, and want to generate stories for all your (new) components at any point, you can use the @nx/angular:stories generator:

Terminal window
nx g @nx/angular:stories --project=<project-name>

Let's take for a example a library in your workspace, under libs/feature/ui, called feature-ui. This library contains a component, called my-button.

The command to generate stories for that library would be:

Terminal window
nx g @nx/angular:stories --project=feature-ui

and the result would be the following:

  • Directoryworkspace name/
    • Directoryapps/
    • Directorylibs/
      • Directoryfeature/
        • Directoryui/
          • Directory.storybook/
        • Directorysrc/
          • Directorylib
            • Directorymy-button
              • my-button.ts
              • my-button.stories.ts
              • etc...
          • etc...
        • README.md
        • tsconfig.json
        • etc...
      • etc...
      • etc...
    • nx.json
    • package.json
    • README.md
    • etc...

Let's take for example a library in your workspace, under libs/feature/ui, called feature-ui with a component, called my-button.

Let's say that the template for that component looks like this:

libs/feature/ui/src/lib/my-button/my-button.html
<button [disabled]="disabled" [ngStyle]="{ 'padding.px': padding }">
{{ text }}
</button>

and the component looks like this:

libs/feature/ui/src/lib/my-button/my-button.ts
import { Component, Input } from '@angular/core';
@Component({
selector: 'feature-ui-my-button',
standalone: true,
templateUrl: './my-button.html',
styleUrls: ['./my-button.css'],
})
export class MyButton {
@Input() text = 'Click me!';
@Input() padding = 10;
@Input() disabled = true;
}

The @nx/angular:storybook-configuration generator would generate a Story file that looks like this:

libs/feature/ui/src/lib/my-button/my-button.stories.ts
import type { Meta, StoryObj } from '@storybook/angular';
import { MyButton } from './my-button';
import { within } from '@storybook/testing-library';
import { expect } from '@storybook/jest';
const meta: Meta<MyButton> = {
component: MyButton,
title: 'MyButton',
};
export default meta;
type Story = StoryObj<MyButton>;
export const Primary: Story = {
args: {
text: 'Click me!',
padding: 10,
disabled: true,
},
};
export const Heading: Story = {
args: {
text: 'Click me!',
padding: 10,
disabled: true,
},
play: async ({ canvasElement }) => {
const canvas = within(canvasElement);
expect(canvas.getByText(/my-button/gi)).toBeTruthy();
},
};

Notice the interaction test on the second story, inside the play function. This just tests if the default text that appears on generated components exists in the rendered component. You can edit this test to suit your needs. You can read more about interaction tests here.

You will notice that browserTarget is specified for the storybook and build-storybook targets, much like it is done for serve or other targets. Angular needs the browserTarget for Storybook in order to know which configuration to use for the build. If your project is buildable (it has a build target, and uses the main Angular builder - @angular-devkit/build-angular:browser, @angular-devkit/build-angular:application or @angular-devkit/build-angular:browser-esbuild) the browserTarget for Storybook will use the build target, if it's not buildable (or is using another Angular builder) it will use the build-storybook target. You do not have to do anything manually. Nx will create the configuration for you. Even if you are migrating from an older version of Nx, Nx will make sure to change your package.json Storybook targets to match the new schema.

You can read more about the browserTarget in the official Angular documentation.

Your Storybook targets in your project.json (or if you run nx show project my-project --web) will look like this:

project.json
"storybook": {
"executor": "@storybook/angular:start-storybook",
"options": {
...
"browserTarget": "my-project:build"
},
...
},
"build-storybook": {
"executor": "@storybook/angular:build-storybook",
...
"options": {
...
"browserTarget": "my-project:build"
},
...
}

This setup instructs Nx to use the configuration under the build target of my-project when using the storybook and build-storybook executors.

You can find all Storybook-related Nx topics here.

For more on using Storybook, see the official Storybook documentation.

Here's more information on common migration scenarios for Storybook with Nx. For Storybook specific migrations that are not automatically handled by Nx please refer to the official Storybook page

Last updated: